=== debian/changelog ===
embree (4.3.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Matteo F. Vescovi <mfv@debian.org>  Sun, 07 Jan 2024 15:05:56 +0100

embree (4.3.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * debian/control: texlive-lang-greek b-dep added (Closes: #1052881)

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 06 Jan 2024 14:19:32 +0100

embree (4.2.0+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 19 Aug 2023 17:42:24 +0200

embree (4.1.0+dfsg-1) experimental; urgency=medium

  [ Matteo F. Vescovi ]
  * New upstream release
    - debian/: SONAME bump 3 -> 4
  * debian/: useless file removal moved to specific file
  * debian/: avoid installing duplicate CHANGELOG.md
  * debian/control: S-V bump 4.6.1 -> 4.6.2 (no changes needed)
  * debian/rules: force 'Release' as build type

  [ Andrius Merkys ]
  * debian/source/lintian-overrides: file added

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 28 Jun 2023 13:28:28 +0200
